

// ntohs() code from OpenBSD 3.8  (distributed here as excerpt under "fair use")
#define u_int16_t	unsigned short
#define uint16_t	unsigned short


#define __swap16md(x) ({                                                \
	u_int16_t __swap16md_x = (x);                                   \
	                                                                \
	__asm ("rorw $8, %w1" : "+r" (__swap16md_x));                   \
	__swap16md_x;                                                   \
})


#define ntohs(x)	__swap16md(x)


// Test code
unsigned int foo(uint16_t *pw, int *y)
{
	unsigned int    x;
	int             a, b, c, d, e, f, g, h, i, j, k;

	x = ntohs(*pw);		// The salient assignment


	// Flim-flam to flush 'x' to stack
	a = b = c = d = e = f = g = h = i = j = 23;
	for (k=0; k<15; k++) {
		a = b;
		b = c;
		c = d;
		d = e;
		e = f;
		f = g;
		g = h;
		h = i;
		i = j;
		j = a + b;
	}
	*y = a;


	return x;
}


#ifdef WITH_MAIN
#include <stdio.h>

int main()
{
	uint16_t	a;
	unsigned int	b;
	int		c;

	a = 0x1234;
	b = foo(&a, &c);

	printf("Result: %x\n", b);

	return 0;
}
#endif

